import { PlatformAccessory } from 'homebridge';
import { EufySecurityPlatform } from '../platform';
import { Station } from 'eufy-security-client';
/**
 * Platform Auto Accessory
 * An instance of this class is created for each accessory your platform registers
 * Each accessory may expose multiple services of different service types.
 */
export declare class AutoSyncStationAccessory {
    private accessory;
    private device;
    private static first;
    private static alarmFired;
    private static childs;
    private static first_station;
    readonly name: string;
    protected guardModeChangeTimeout: {
        timeout: NodeJS.Timeout | null;
        delay: number;
    };
    protected static alarmFiredTimeout: {
        timeout: NodeJS.Timeout | null;
        delay: number;
    };
    constructor(platform: EufySecurityPlatform, accessory: PlatformAccessory, device: Station);
    private initChildEventRegister;
    /**
     * Handle requests to set the 'Security System Target State' to all childs
     */
    private changeModeToAllChilds;
    /**
     * Handle requests to synchronize alarm events to all child stations.
     * @param station The station triggering the alarm event.
     * @param alarmEvent The type of alarm event.
     */
    private fireAlarmToAllChilds;
    /**
     * Handle requests to set the 'Security System Target State' characteristic
     */
    protected handleSecuritySystemTargetStateSet(mode: number): void;
}
//# sourceMappingURL=AutoSyncStationAccessory.d.ts.map