import { PlatformAccessory } from 'homebridge';
import { EufySecurityPlatform } from '../platform';
import { DeviceAccessory } from './Device';
import { EntrySensor } from 'eufy-security-client';
/**
 * EntrySensorAccessory Class
 *
 * This class represents an entry sensor accessory within a home automation system. It is designed
 * to integrate entry sensors into the system, register appropriate characteristics, and provide
 * necessary functionality for monitoring the open or closed state of doors or windows.
 *
 * @class EntrySensorAccessory
 * @extends DeviceAccessory
 */
export declare class EntrySensorAccessory extends DeviceAccessory {
    /**
     * Constructor for EntrySensorAccessory.
     *
     * @param {EufySecurityPlatform} platform - The platform instance managing accessories.
     * @param {PlatformAccessory} accessory - The platform-specific accessory.
     * @param {EntrySensor} device - The entry sensor device being represented.
     */
    constructor(platform: EufySecurityPlatform, accessory: PlatformAccessory, device: EntrySensor);
}
//# sourceMappingURL=EntrySensorAccessory.d.ts.map