import { PlatformAccessory } from 'homebridge';
import { EufySecurityPlatform } from '../platform';
import { DeviceAccessory } from './Device';
import { MotionSensor } from 'eufy-security-client';
/**
 * MotionSensorAccessory Class
 *
 * This class represents a motion sensor accessory within a home automation system. It is designed
 * to integrate motion sensors into the system, register appropriate characteristics, and provide
 * necessary functionality for motion detection.
 *
 * @class MotionSensorAccessory
 * @extends DeviceAccessory
 */
export declare class MotionSensorAccessory extends DeviceAccessory {
    /**
     * Constructor for MotionSensorAccessory.
     *
     * @param {EufySecurityPlatform} platform - The platform instance managing accessories.
     * @param {PlatformAccessory} accessory - The platform-specific accessory.
     * @param {MotionSensor} device - The motion sensor device being represented.
     */
    constructor(platform: EufySecurityPlatform, accessory: PlatformAccessory, device: MotionSensor);
}
//# sourceMappingURL=MotionSensorAccessory.d.ts.map