import { EventEmitter, Readable } from 'stream';
import { Station, Device, StreamMetadata } from 'eufy-security-client';
import { CameraAccessory } from '../accessories/CameraAccessory';
import { ILogObj, Logger } from 'tslog';
type StationStream = {
    station: Station;
    device: Device;
    metadata: StreamMetadata;
    videostream: Readable;
    audiostream: Readable;
    createdAt: number;
};
export declare class LocalLivestreamManager extends EventEmitter {
    private camera;
    private readonly CONNECTION_ESTABLISHED_TIMEOUT;
    private stationStream;
    private livestreamStartedAt;
    private livestreamIsStarting;
    private eufyClient;
    readonly log: Logger<ILogObj>;
    private readonly serial_number;
    constructor(camera: CameraAccessory);
    private initialize;
    getLocalLivestream(): Promise<StationStream>;
    private startAndGetLocalLiveStream;
    stopLocalLiveStream(): void;
    private onStationLivestreamStop;
    private onStationLivestreamStart;
}
export {};
//# sourceMappingURL=LocalLivestreamManager.d.ts.map