"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SnapshotUnavailablePath = exports.SnapshotBlackPath = exports.PROTECT_TWOWAY_HEARTBEAT_INTERVAL = exports.PROTECT_SNAPSHOT_CACHE_MAXAGE = exports.PROTECT_FFMPEG_AUDIO_FILTER_FFTNR = exports.PROTECT_RPI_GPU_MINIMUM = exports.PROTECT_HOMEKIT_IDR_INTERVAL = exports.PROTECT_HOMEKIT_STREAMING_HEADROOM = exports.PROTECT_HKSV_SEGMENT_RESOLUTION = exports.PROTECT_HKSV_TIMESHIFT_BUFFER_MAXLENGTH = exports.PROTECT_HKSV_MAX_EVENT_ERRORS = exports.PROTECT_HKSV_SEGMENT_LENGTH = exports.DEVICE_INIT_DELAY = exports.STATION_INIT_DELAY = exports.PLUGIN_NAME = exports.PLATFORM_NAME = void 0;
/**
 * This is the name of the platform that users will use to register the plugin in the Homebridge config.json
 */
exports.PLATFORM_NAME = 'EufySecurity';
/**
 * This must match the name of your plugin as defined the package.json
 */
exports.PLUGIN_NAME = 'homebridge-eufy-security';
exports.STATION_INIT_DELAY = 5 * 1000; // 5 seconds
exports.DEVICE_INIT_DELAY = 7 * 1000; // 7 seconds;
// HomeKit Secure Video segment length, in milliseconds. HomeKit only supports this value currently.
exports.PROTECT_HKSV_SEGMENT_LENGTH = 4000;
// HomeKit Secure Video maximum event recording errors to accept before resetting a connection to the Protect controller.
exports.PROTECT_HKSV_MAX_EVENT_ERRORS = 3;
// HomeKit Secure Video timeshift buffer default length, in milliseconds. This defines how far back in time we can look when we see a motion event.
exports.PROTECT_HKSV_TIMESHIFT_BUFFER_MAXLENGTH = exports.PROTECT_HKSV_SEGMENT_LENGTH * 2;
// HomeKit Secure Video segment resolution, in milliseconds. This defines the resolution of our buffer. It should never be less than 100ms or greater than 1500ms.
exports.PROTECT_HKSV_SEGMENT_RESOLUTION = 100;
// Additional headroom for bitrates beyond what HomeKit is requesting when streaming to improve quality with a minor additional bandwidth cost.
exports.PROTECT_HOMEKIT_STREAMING_HEADROOM = 64;
// HomeKit prefers a video streaming I-frame interval of 2 seconds.
exports.PROTECT_HOMEKIT_IDR_INTERVAL = 2;
// Minimum required GPU memory on a Raspberry Pi for hardware acceleration.
exports.PROTECT_RPI_GPU_MINIMUM = 128;
// FFmpeg afftdn audio filter defaults - this setting uses FFTs to reduce noise in an audio signal by the number of decibels below.
exports.PROTECT_FFMPEG_AUDIO_FILTER_FFTNR = 90;
// Maximum age of a snapshot in seconds.
exports.PROTECT_SNAPSHOT_CACHE_MAXAGE = 90;
// How often, in seconds, should we heartbeat FFmpeg in two-way audio sessions. This should be less than 5 seconds, which is FFmpeg's input timeout interval.
exports.PROTECT_TWOWAY_HEARTBEAT_INTERVAL = 3;
exports.SnapshotBlackPath = '/media/Snapshot-black.png';
exports.SnapshotUnavailablePath = '/media/Snapshot-Unavailable.png';
//# sourceMappingURL=settings.js.map