"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.reserve = void 0;
const net = require("node:net");
async function reserve(ip, port) {
    const server = net.createServer();
    await new Promise((resolve, reject) => {
        server.unref();
        server.on('error', reject);
        server.listen({ host: ip, port, exclusive: true }, () => {
            server.close(() => resolve());
        });
    });
}
exports.reserve = reserve;
