/**
 * @preserve date-and-time.js locale configuration
 * @preserve Greek (el)
 * @preserve It is using moment.js locale configuration as a reference.
 */

var el = function (date) {
    var code = 'el';

    date.locale(code, {
        res: {
            MMMM: [
                ['Ιανουάριος', 'Φεβρουάριος', 'Μάρτιος', 'Απρίλιος', 'Μάιος', 'Ιούνιος', 'Ιούλιος', 'Αύγουστος', 'Σεπτέμβριος', 'Οκτώβριος', 'Νοέμβριος', 'Δεκέμβριος'],
                ['Ιανουαρίου', 'Φεβρουαρίου', 'Μαρτίου', 'Απριλίου', 'Μαΐου', 'Ιουνίου', 'Ιουλίου', 'Αυγούστου', 'Σεπτεμβρίου', 'Οκτωβρίου', 'Νοεμβρίου', 'Δεκεμβρίου']
            ],
            MMM: ['Ιαν', 'Φεβ', 'Μαρ', 'Απρ', 'Μαϊ', 'Ιουν', 'Ιουλ', 'Αυγ', 'Σεπ', 'Οκτ', 'Νοε', 'Δεκ'],
            dddd: ['Κυριακή', 'Δευτέρα', 'Τρίτη', 'Τετάρτη', 'Πέμπτη', 'Παρασκευή', 'Σάββατο'],
            ddd: ['Κυρ', 'Δευ', 'Τρι', 'Τετ', 'Πεμ', 'Παρ', 'Σαβ'],
            dd: ['Κυ', 'Δε', 'Τρ', 'Τε', 'Πε', 'Πα', 'Σα'],
            A: ['πμ', 'μμ']
        },
        formatter: {
            MMMM: function (d, formatString) {
                return this.res.MMMM[/D.*MMMM/.test(formatString) | 0][d.getMonth()];
            },
            hh: function (d) {
                return ('0' + d.getHours() % 12).slice(-2);
            },
            h: function (d) {
                return d.getHours() % 12;
            }
        },
        parser: {
            MMMM: function (str, formatString) {
                var result = this.find(this.res.MMMM[/D.*MMMM/.test(formatString) | 0], str);
                result.value++;
                return result;
            }
        }
    });
    return code;
};

export { el as default };
