import { CategoryConfigOptional } from "../api/CategoryConfig";
import { CategoryProvider } from "../api/CategoryProvider";
import { CategoryControl } from "../api/CategoryControl";
/**
 * Provider for the category flavor, each provider is a unique instance that can be used to
 * get categories/loggers from.
 */
declare class CategoryProviderService {
    private readonly _log;
    private readonly _providers;
    createLogProvider(name: string, config?: CategoryConfigOptional): CategoryProvider;
    getCategoryControl(fnValue?: (msg: string) => void): CategoryControl;
    clear(): void;
    private showSettings;
    private getCategoryControlProviderByIdOrName;
    private static help;
}
/**
 * Singleton instance to the service, for internal usage only. Must NOT be exported to end user.
 */
export declare const CATEGORY_PROVIDER_SERVICE: CategoryProviderService;
export declare const CATEGORY_LOG_CONTROL: (fnValue?: (msg: string) => void) => CategoryControl;
export {};
//# sourceMappingURL=CategoryProviderService.d.ts.map