import { LogChannel, LogMessage, RawLogChannel, RawLogMessage } from "../main/core";
/**
 * LogChannel that pushes log messages to a buffer.
 */
export declare class ArrayLogChannel implements LogChannel {
    private readonly _buffer;
    readonly type = "LogChannel";
    write(msg: LogMessage): void;
    get logMessages(): LogMessage[];
    get messages(): string[];
}
/**
 * RawLogChannel that pushes raw log messages to a buffer.
 */
export declare class ArrayRawLogChannel implements RawLogChannel {
    private _buffer;
    readonly type = "RawLogChannel";
    write(msg: RawLogMessage, _: (arg: unknown) => string): void;
    get messages(): ReadonlyArray<string>;
    get errors(): ReadonlyArray<Error | undefined>;
    get size(): number;
    get rawMessages(): ReadonlyArray<RawLogMessage>;
    clear(): void;
}
/**
 * Test class to help test the log control.
 */
export declare class TestControlMessage {
    private _messages;
    constructor();
    get messages(): string[];
    write(msg: string): void;
    clear(): void;
}
//# sourceMappingURL=TestClasses.d.ts.map